<?php
declare (strict_types = 1);

namespace app\cxinv\controller;

use app\common\Ocr;
use app\cxinv\model\GodTemp;
use app\user\model\TaxCompany;
use think\App;
use think\Request;

class Index extends Base
{

    public function __construct(App $app)
    {
        parent::__construct($app);
    }
    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {
        $param=request()->param();
        $ocr= Ocr::getInstance();
        $code=$param['code'];
        $number=$param['number'];
        $issueDate=$param['issueDate'];
        $checkCode=$param['checkCode'];
        $subtotalAmount=$param['subtotalAmount'];

        $data=$ocr->InvoiceVerification($code,$number,$issueDate,$checkCode,$subtotalAmount);

      return  json($data);

    }
    //商品库模糊查询
    public function List()
    {
        $param = $this->request->param(['goodName'=>"","code"=>"","companyNo"=>"","page"=>1,"size"=>20],"post",'trim');
       $where=[["status","<>",0]];
       if($param['goodName']!='') $where[]=['goodName','like','%'.$param['goodName'].'%'];
       if($param['code']!='') $where[]=['code','like','%'.$param['code'].'%'];
       if($param['companyNo']!=''){
           $inTax = TaxCompany::with(['tax'])->where(['companyNo'=>$param['companyNo'],'income'=>1])->select();
           $magerCode= array_column($inTax->toArray(),'merge_code');
           $where[]=['cat_code','in',$magerCode];
       }

       $list = GodTemp::with(['tax_info'])->where($where)->order('id desc')->paginate(['page'=>$param['page'],'list_rows'=>$param['size']]);
       return success("获取成功",['list'=>$list->items(),'count'=>$list->total()]);
    }

    /**
     * 保存新建的资源
     *
     * @param  \think\Request  $request
     * @return \think\Response
     */
    public function ListV2()
    {
        $param = $this->request->param(['goodName'=>"","code"=>"","companyNo"=>"","page"=>1,"size"=>20],"post",'trim');
        $where=[["a.status","<>",0],["tax_category.is_del","=",0]];
        if($param['goodName']!='') $where[]=['a.goodName|tax_category.cat_code|tax_category.cat_name|tax_category.merge_code|tax_category.short_name','like','%'.$param['goodName'].'%'];

        $list = GodTemp::alias('a')->leftJoin("zswh_account_202304.sys_tax_category tax_category",'tax_category.merge_code=a.cat_code')
            ->where($where)->field("a.id,a.code,a.goodName,a.cat_tax,a.cat_code,a.cat_name,tax_category.cat_code tax_cat_code,
            tax_category.cat_name tax_cat_name, merge_code,short_name,1 is_check,tax_category.id tax_id")
            ->order('a.id desc')->paginate(['page'=>$param['page'],'list_rows'=>$param['size']])->each(function ($item,$key)use($param){
                $inTax = TaxCompany::with(['tax'])->where(['companyNo'=>$param['companyNo'],'income'=>1,'tax_id'=>$item->tax_id])->findOrEmpty();
                $item->is_check=$inTax->isEmpty()?0:1;
            });
        return success("获取成功",['list'=>$list->items(),'count'=>$list->total()]);
    }

    /**
     * 显示指定的资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function read($id)
    {
        //
    }

    /**
     * 显示编辑资源表单页.
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * 保存更新的资源
     *
     * @param  \think\Request  $request
     * @param  int  $id
     * @return \think\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * 删除指定资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function delete($id)
    {
        //
    }
}
