<?php
declare (strict_types = 1);

namespace app\cxinv\listener;

use think\Exception;

class ReportCode
{
    protected $model;
    /**
     * 事件监听处理
     *
     * @return mixed
     */
    public function handle($event)
    {
        $this->model = new \app\cxinv\model\ReportCode();
        try{
            if($event['type']=='add'){

                $this->addField($event);
            }
            if ($event['type']=='sub'){
                $this->subField($event);
            }
        }catch (\Exception $e){
            throw new Exception($e->getMessage(),1004);
        }

    }

    private function subField($param){
        if(is_string($param['value'])){
            $this->model->whereFindInSet($param['key'],$param['value'])->select()->each(function($item)use($param){
                $item->rmField($param['key'],$item[$param['key']]);
            });
        }
        if(is_array($param['value'])){
           foreach ($param['value'] as $v){
              $this->model->whereFindInSet($param['key'],$v)->select()->each(function($item)use($param){
                              $item->rmField($param['key'],$item[$param['key']]);
                          });
           }
        }
    }

    private function addField($param)
    {
        if (is_string($param['main']['value'])) {
            $this->model->where([$param['main']['key'] => $param['main']['value']])->findOrEmpty()->addField($param['key'], $param['value']);
        }
        if (is_array($param['main']['value'])) {
            foreach ($param['main']['value'] as $v) {
                $this->model->where([$param['main']['key'] => $v])->findOrEmpty()->addField($param['key'], $param['value']);
            }
        }
    }
}
